# libflame library

libflame is a portable library for dense matrix computations, providing
much of the functionality present in LAPACK, developed by current and
former members of the
[Science of High-Performance Computing](http://shpc.ices.utexas.edu/)
(SHPC) group in the
[Institute for Computational Engineering and Sciences](https://www.ices.utexas.edu/)
at [The University of Texas at Austin](https://www.utexas.edu/).
libflame includes a compatibility layer, lapack2flame, which includes
a complete LAPACK implementation.
The source code for libflame is hosted on github:

  https://github.com/flame/libflame

For detailed instructions on how to configure, build, install, and link
against libflame, please refer to the libflame reference manual.
This manual contains all the information you need to get started with
libflame, including installation directions, usage examples, and a
complete API reference. If you have LaTeX installed on your system, you
may simply change into the 'docs/libflame' subdirectory of the top-level
directory of the libflame source tree and build the document from its
source. You may also find a copy of the document
[here](docs/libflame/libflame.pdf) on github.

You can keep in touch with developers and other users of the project by
joining the following mailing list:
- [libflame-discuss](http://groups.google.com/group/libflame-discuss)
Please join and post to this mailing list if you have general questions
or feedback regarding libflame.
- NOTE: We do not yet have a developer's mailing list. For now,
developers and those with developer-related questions can simply post
to libflame-discuss.

If you encounter any problems or wish to submit a bug report, please
consider [opening an issue](https://github.com/flame/libflame/issues) here
on github.

Also, please read the LICENSE file for information on copying and
distributing this software.

Thanks for your interest in libflame!

Regards,

[Field G. Van Zee](https://github.com/fgvanzee)
(for the SHPC team)
